/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : glue.cc
Last edit : 10/20/92
Created   :
Version   : 1.18

History   :

Does      :
*/
#include <stdlib.h>
#include <string.h>
#include <curses.h>
#include <unistd.h>
#include <fcntl.h>
#include <paths.h>
#include <mcform.h>
#include <limits.h>

#include "misc_info.h"
#include "st.h"
#include "stat.h"
#include "profe_mai.h"
#include "race_main.h"
#include "item.h"
#include "special.h"

#ifndef __cplusplus__
#define __cplusplus__
#endif

#include "chosen.h"

extern "C" {
  char 			*get_word(FILE *);
  void 			put_misc_info(struct misc_info *);
  struct misc_info 	*get_misc_info(struct misc_info *);
  void			siemen(void);
  int			sattuma(int,int);
  char			*mstrtok(char *, char *);
};
 
void get_misc_info(char *, char *);
void head(char *, FILE *dst);
void resistances(FILE *dst);
void background(char *, FILE *dst);
void skills(char *, FILE *dst);

static struct race_main race;
static struct profe_mai profe;

static role_stat rstats;

static int gp=0;
static int sp=0;
static int bp=0;
static int cp=0;

static float power_base=0.0;
static float power_mp=0.0;
static int lvl=0;

OS_CHOSEN lst=NULL;
 
void do_glue(char *arg)
{
  char *puskuri=NULL;
  int len=0;
  char *d=NULL;
  int old=1;
  int uusi=1;
  FILE *dst;

  len = strlen(arg) * 2 + strlen(SAVE) + 14;

  puskuri = (char *)malloc(len);
  if(!puskuri) {
    perror("malloc/glue.cc");
    exit(0);
  }

  d = mstrtok(arg," \t\n\0");
  if(!d) {
    perror("malloc/glue.cc");
    exit(0);
  }
  sprintf(puskuri,"%s/%s/%s.misc",SAVE,d,d);  
  
  if(access(puskuri,0))
     get_misc_info(puskuri,d);

  sprintf(puskuri,"%s/%s/%s",SAVE,d,d);
  dst = fopen(puskuri,"w");
  if(!dst) {
    perror(puskuri);
    exit(0);
  }
  head(d,dst);
  rstats.dump_stats(dst);
  fprintf(dst,"\nDB: %3i  Misc:     Shield:    Magic:     ADDB:     Total:    \n",
	  rstats.get_total(6));
  resistances(dst);
  background(d,dst);
  skills(d,dst);
  fclose(dst);
  return;
}

void head(char *name, FILE *dst)
{
  char *nimi=NULL;
  int len=0;
  char char_name[100];
  int smoney=0;
  char slaji[5];
  char sclass[30];
  int jalat;
  int tuumat;
  int bmb;
  int paino;
  FILE *src;
  
  len = strlen(SAVE) + 2 * strlen(name) + 16;
  nimi = (char *) malloc(len);
  if(!nimi) {
    perror("glue.cc/malloc()");
    exit(0);
  };
  sprintf(nimi,"%s/%s/%s.fstats",SAVE,name,name);
  rstats.load(nimi);
  
  sprintf(nimi,"%s/%s/%s.name",SAVE,name,name);
  src = fopen(nimi,"r");
  if(src) {
    fgets(char_name,80,src);
    fclose(src);
  }
  else
    sprintf(char_name,"%s",name);

  sprintf(nimi,"%s/%s/%s.race",SAVE,name,name);
  src = fopen(nimi,"r");
  if(!src) {
    perror("glue.cc/fopen():race");
    exit(0);
  }
  fread(&race,sizeof(struct race_main),1,src);
  fclose(src);
  
  sprintf(nimi,"%s/%s/%s.profe",SAVE,name,name);
  src = fopen(nimi,"r");
  if(!src) {
    perror("glue.cc/fopen():profe");
    exit(0);
  }
  fread(&profe,sizeof(struct profe_mai),1,src);
  fclose(src);
  
  sprintf(nimi,"%s/%s/.lvl",SAVE,name);
  src = fopen(nimi,"r");
  if(!src) {
    perror("glue.cc/fopen():lvl");
    exit(0);
  }
  lvl = getw(src);
  fclose(src);

  sprintf(nimi,"%s/%s/%s.misc",SAVE,name,name);
  src = fopen(nimi,"r");
  if(!src) {
    perror("glue.cc/fopen():misc");
    exit(0);
  }
  smoney = atoi(get_word(src));
  sprintf(slaji,"%s",get_word(src));
  sprintf(sclass,"%s",get_word(src));
  
  jalat = atoi(get_word(src));
  tuumat = atoi(get_word(src));
  bmb = atoi(get_word(src));
  paino = atoi(get_word(src)); 
  fclose(src);
 
  fprintf(dst,"\n\nName        : %-28s  Race: %-28s\n",char_name, race.race);
  fprintf(dst,"Profession  : %-30s\n", profe.profession);
  fprintf(dst,"Height      : %-2i' %-2i''                      Weight: %3i  Lvl: %3i\n",
	  jalat,tuumat,paino, lvl);
  fprintf(dst,"Social Class: %s\n",sclass);
  fprintf(dst,"Base move   : %-3i                           Weight allowance: %3i\n\n",
	  rstats.get_total(6)+bmb+50, paino / 10);
  
  if(!strcmp(slaji,"GP"))
    gp = smoney;

  if(!strcmp(slaji,"SP"))
    sp = smoney;

  if(!strcmp(slaji,"BP"));
    bp = smoney;

  if(!strcmp(slaji,"CP"));
    cp = smoney;

  return;
}    
  
void resistances(FILE *dst)
{
  int ess=0;
  int men=0;
  int cha=0;
  int poi=0;
  int arc=0;
  int dis=0;
  int fea=0;

  fprintf(dst,"\nResistances:\n");

  if(!strcmp(profe.realm,"Es")) {
    ess+=15;
    power_base = rstats.get_tmp(9) / 10.0;
    power_mp   = 1.0 + rstats.get_total(9) / 100.0;
  };

  if(!strcmp(profe.realm,"Ch")){
    cha+=15;
    power_base = rstats.get_tmp(8) / 10.0;
    power_mp   = 1.0 + rstats.get_total(8) / 100.0;
  };

  if(!strcmp(profe.realm,"Me")) {
    men+15;
    power_base = rstats.get_tmp(7) / 10.0;
    power_mp   = 1.0 + rstats.get_total(7) / 100.0;
  };

  if(!strcmp(profe.realm,"All")) {
    ess+=5;
    cha+=5;
    men+=5;
    power_base = (rstats.get_tmp(9) + rstats.get_tmp(7) + rstats.get_tmp(8)) / 30.0;
    power_mp = 1.0 + (rstats.get_total(9) + rstats.get_total(8)+rstats.get_total(7)) / 300.0;
  }

  if(!strcmp(profe.realm,"Me/Ch") || !strcmp(profe.realm,"Ch/Me")) {
    cha += 7;
    men += 7;
    power_base = (rstats.get_tmp(7) + rstats.get_tmp(8)) / 20.0;
    power_mp = 1.0 + (rstats.get_total(8)+rstats.get_total(7)) / 200.0;
  }

  if(!strcmp(profe.realm,"Es/Ch") || !strcmp(profe.realm,"Ch/Es")) {
    cha += 7;
    ess += 7;
    power_base = (rstats.get_tmp(9) + rstats.get_tmp(8)) / 20.0;
    power_mp = 1.0 + (rstats.get_total(8)+rstats.get_total(9)) / 200.0;
  }

  if(!strcmp(profe.realm,"Me/Es") || !strcmp(profe.realm,"Es/Me")) {
    ess += 7;
    men += 7;
    power_base = (rstats.get_tmp(7) + rstats.get_tmp(9)) / 20.0;
    power_mp = 1.0 + (rstats.get_total(9)+rstats.get_total(7)) / 200.0;
  }

  ess += race.ess + rstats.get_total(9);
  cha += race.cha + rstats.get_total(8);
  men += race.men + rstats.get_total(7);
  
  arc = (ess + cha + men) / 3;
  poi += race.poi + rstats.get_total(0);
  dis += race.dis + rstats.get_total(0);

  fea += rstats.get_total(1);

  fprintf(dst,"Essence   : %3i  Diseases : %3i\n",ess, dis);
  fprintf(dst,"Channeling: %3i  Poison   : %3i\n",cha, poi);
  fprintf(dst,"Mentalism : %3i  Fear     : %3i\n",men, fea);

  fprintf(dst,"\nArcane    : %3i\n",arc);
 
  return;
}

void background(char *name, FILE *dst)
{
  char *nimi=NULL;
  int len=0;
  FILE *src;
  int gold=0;
  int rands=0;
  int lang=0;
  int slkm=0;
  int ilkm=0;
  struct item it;
  struct special spe;
  int i=0;
 
  len = strlen(SAVE) + 2 * strlen(name) + 16;
  nimi = (char *) malloc(len);
  if(!nimi) {
    perror("glue.cc/malloc()");
    exit(0);
  };
  sprintf(nimi,"%s/%s/%s.backg",SAVE,name,name);

  src = fopen(nimi,"r");
  if(!src) {
    perror("fopen/backg");
    exit(0);
  }
 
  lang = getw(src);
  rands = getw(src);
  gold = getw(src);
  ilkm = getw(src);
  slkm = getw(src);

  fprintf(dst,"\nItems:\n");
  for(i=0;i<ilkm;i++) {
    if(fread(&it,sizeof(struct item),1,src)!=1) 
      break; 
   fprintf(dst,"%s\n",it.name);
  };
  fprintf(dst,"\nSpecial:\n");
  for(i=0;i<slkm;i++) {
    if(fread(&spe, sizeof(struct special),1,src)!=1)
      break;
   fprintf(dst,"%s\n",spe.name);
  };
  fclose(src);
  if(rands)
    fprintf(stderr,"\nSorry: %i random skills\n",rands); 
  fprintf(dst,"\nMoney:\n");
  gp += gold; 
  fprintf(dst,"GP %3i  SP: %3i  BP: %3i  CP: %3i\n", gp, sp, bp, cp);
  fprintf(dst,"\nLanguage____|_Written_|_Spoken_|\n");
  for(i=0;i<lang+race.lang;i++)
   fprintf(dst,"____________|_________|________|\n"); 
  fprintf(dst,"\n");
  return;
}

void skills(char *name, FILE *dst)
{
  char *nimi=NULL;
  int len=0;
  FILE *src;
  int i=0;
  OS_CHOSEN n=NULL;
  int hits=0;
  int power=0;
  char *snames[11]={"","CO","SD","AG","MQ","RE","ST","QU","PR","IN","EM"};
  float hits_base = 0.0;
  float hits_ranks = 0.0;
  float hits_levels = 0.0;
  int	hits_total = 0;
  float power_ranks = 0.0;
  float power_levels = 0.0;
  int   power_total =0;
  int   sbonus =0;
  int   rbonus = 0;
  int   lvlbonus =0;

  len = strlen(SAVE) + 2 * strlen(name) + 16;
  nimi = (char *) malloc(len);
  if(!nimi) {
    perror("glue.cc/malloc()");
    exit(0);
  };
  sprintf(nimi,"%s/%s/%s.skills",SAVE,name,name);
  lst = load_skill_lst(nimi);
 
  n = lst;
  while(n && strncmp(n->skill,"Body deve",7)) n=n->seur;

  hits_base = (float)rstats.get_tmp(0) / 10.0;
  hits_ranks = 0.0;
  hits_levels = 0.0;

  if(n) 
    for(i=0;i<n->ranks;i++) {
      hits_levels+=(float)n->lvl;
      hits_ranks += (float)sattuma(1,race.dice);
  };
         
  hits_total = (int)((hits_ranks + hits_levels + hits_base) * (1.0 + (float)rstats.get_total(0) /100.0));

  fprintf(dst,"HP: (%3.0f + %3.0f + %5.2f) * (1.0 + %5.2f) = %3i\n\n",
          hits_ranks, hits_levels, hits_base, (float)rstats.get_tmp(0) / 100.0,
          hits_total);

  n = lst;
  while(n && strncmp(n->skill,"P.P deve",7)) n=n->seur;

  if(strcmp(profe.realm,"None")) {    
    power_ranks = 0.0;
    power_levels = 0.0;

    if(n) 
      for(i=0;i<n->ranks;i++) {
        power_levels+=(float)n->lvl;
        power_ranks += (float)sattuma(1,5);
    };
         
    power_total = (int)((power_ranks + power_levels + power_base) * power_mp);
   fprintf(dst,"PP: (%3.0f + %3.0f + %5.2f) * %5.2f = %3.0i\n\n",
            power_ranks, power_levels, power_base, power_mp, power_total);
  }
  n = lst;
  fprintf(dst,"Skill:_____________|__Stats_|_Costi__|Ranks|Rank_|Stat_|Lvl|Mis|Total|\n");
  while(n) {
    fprintf(dst,"%-19s|",n->skill);
     sbonus = 0;	
     if(n->stata >-1 && n->stata < 11) {
       fprintf(dst,"%2s/",snames[n->stata]);	
       if(n->statb >-1 && n->statb < 11) {
         fprintf(dst,"%2s/",snames[n->statb]);
	 if(n->statc > -1 && n->statc < 11) {
	   fprintf(dst,"%2s|",snames[n->statc]);
	   sbonus = (rstats.get_total(n->stata-1) + rstats.get_total(n->statb-1) + rstats.get_total(n->statc-1)) /3; 		     
	 } else {
	   fprintf(dst,"  |");
	   sbonus = (rstats.get_total(n->stata-1) + rstats.get_total(n->statb-1)) /2;
	 }
       }
       else {
       	 fprintf(dst,"  /  |");
       	 sbonus = rstats.get_total(n->stata-1);
       }
     }
     else {
     	sbonus = 0;
     	fprintf(dst,"  /  /  |");
     }
     fprintf(dst,"%2i/",n->costa);
     if(n->costb != -1) {
       if(!n->costb)
         fprintf(dst," */  |");
       else {
       	 fprintf(dst,"%2i/",n->costb);
       	 if(n->costc != -1) {
       	   if(!n->costc)
       	     fprintf(dst," *|");
       	   else
       	     fprintf(dst,"%2i|",n->costc);
       	 }
	 else
	   fprintf(dst,"  |");
       }
     }
     else
       fprintf(dst,"  /  |");	
     fprintf(dst," %3i |",n->ranks);
     rbonus = 0;	
     if(n->ranks < 10)
       rbonus = n->ranks *5;
     else
       if(n->ranks < 20)
         rbonus = 50 + (n->ranks -10) *2;
       else
         rbonus = 50 + 20 + (n->ranks -10);
     if(!n->ranks)
        rbonus = -25;	
     lvlbonus = lvl * n->lvl;
     fprintf(dst," %3i | %3i |%3i|   | %3i |\n",
	rbonus, sbonus, lvlbonus, rbonus+sbonus+lvlbonus);
     lst = lst->seur;
     free(n);
     n = lst;	
  }
}
    
void get_misc_info(char *name, char *tdsto)
{
  struct social {
    int raja;	
    int money;
    char laji[4];
    char luokka[30];
  } luokat[11];
  struct boonus {
    int jalat;
    int tuumat;
    int bonu;
  } boonukset[10];
  int rolli = 0;
  char *a=NULL;
  FILE *src;
  struct misc_info mi;
  int i=0;
  FILE *dst;
  char puskuri[50];
  int j=0;

  mi.feet = 0;
  mi.inches = 0;
  mi.lbs = 0;

  src = fopen(SOCIAL,"r");
  if(!src) {
    perror("fopen/glue.cc");
    exit(0);
  }
  for(i=0;i<11;i++) {
    a = get_word(src);
    luokat[i].raja = atoi(a);
    a = get_word(src);
    luokat[i].money = atoi(a);
    sprintf(luokat[i].laji,"%2s",get_word(src));
    sprintf(luokat[i].luokka,"%-22s",get_word(src));
  }

  for(i=0;i<10;i++) {
    a = get_word(src);
    boonukset[i].jalat = atoi(a);
    a = get_word(src);
    boonukset[i].tuumat = atoi(a);
    a = get_word(src);
    boonukset[i].bonu = atoi(a);
  }

  fclose(src);

  siemen();
  rolli = sattuma(1,100);
  i =0;
  while((i < 11) && (luokat[i].raja < rolli)) i++;
  sprintf(mi.sclass,"%s",luokat[i].luokka);
  sprintf(mi.laji,"%s",luokat[i].laji);
  mi.sgp = luokat[i].money;

  falku();
  put_misc_info(&mi);
  get_misc_info(&mi);
  clear();
  floppu();
  i = 0;
  while(i<10 && (mi.feet < boonukset[i].jalat)) 
      i++;
  if((i<9) && (mi.inches <= boonukset[i].tuumat) && (mi.feet == boonukset[i].jalat))
     i++;

  dst = fopen(name,"w");
  if(!dst) {
    perror("fopen/glue.cc");
    exit(0);
  }

  sprintf(puskuri,"%3i",mi.sgp);
  fprintf(dst,"%s\n",puskuri);

  fprintf(dst,"%s\n",mi.laji);
  
  for(j=0;j<strlen(mi.sclass);j++)
     if(mi.sclass[j]==' ')
       mi.sclass[j]='_'; 
  
  fprintf(dst,"%s\n",mi.sclass);
 
  sprintf(puskuri,"%3i",mi.feet);
  fprintf(dst,"%s\n",puskuri);

  sprintf(puskuri,"%3i",mi.inches);
  fprintf(dst,"%s\n",puskuri);

  sprintf(puskuri,"%3i",boonukset[i].bonu);
  fprintf(dst,"%s\n",puskuri);

  sprintf(puskuri,"%3i",mi.lbs);
  fprintf(dst,"%s\n",puskuri);

  fclose(dst);
  return;
}
 
  
